PROGRAM_NAME='Access_Apex_Destiny_6100,Rev 1'
(*  FILE CREATED ON: 05/16/2001 AT: 16:25:49               *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 05/17/2001 AT: 09:59:57         *)
(***********************************************************)
(*!!FILE REVISION: Rev 1                                   *)
(*  REVISION DATE: 05/16/2001                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*          To configure the Apex panel to report and      *)
(*          respond through the RS232 port, there are      *)
(*          several areas that need to be enabled in       *)
(*          panel.  The first is to enable the RS232       *)
(*          adapter, and the 2-way RS232 communication.    *)
(*          To do this, enter programming mode on the      *)
(*          Destiny 6100 (default code: 9173), proceed to  *)
(*          the programming location 0155 and set the      *)
(*          value to 009.  The next items that need to be  *)
(*          enabled are the reporting codes for the        *)
(*          zone types, and system messages.  To do this   *)
(*          proceed to the programming locations 0387      *)
(*          through 0435, the values of those locations    *)
(*          need to be increased by 16 (value 16 enables   *)
(*          RS232 reporting for the specified tupe).       *)
(*          Refer to the security installation company     *)
(*          to make any changes mentioned to the system    *)
(*          programming.                                   *) 
(*                                                         *)
(*                      FIND.APEX.COMMANDS                 *)
(*                      FIND.APEX.SUBCOMMANDS              *) 
(*                      FIND.APEX.VOCABULARY               *)
(*                      FIND.APEX.ZONE.NAMES               *)
(*                      FIND.APEX.PARTITION.NAMES          *)
(*                                                         *)
(***********************************************************)

(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

APEX  = 1         (* Apex Destiny 6100  *)
                  (*    1200/N/8/1      *)
                  (* DCE jumper setting *)
                  (*   FG10-P1878-04    *)
TP    = 128                         
(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

(* !!                                 !! *)
(* !! DO NOT OVERRIDE THESE CONSTANTS !! *)
(* !!                                 !! *)
(* BAR_GRAPH ON TP USED TO DISPLAY LOADING *)
LOADING_BAR = 1

(* FIND.APEX.COMMANDS *)
(* APEX COMMANDS *)
ARM=1
ZONES=2
CONTROL=3
SPEAK=4
LOCATION_PROGRAMMING=5

(* FIND.APEX.SUBCOMMANDS *)
(* APEX_SUBCOMMANDS *)
TO_AWAY=1
TO_HOME=2
DISARM=3
STATUS_REQUEST=4
ZONE_STATUS=5
PARTITION_STATUS=6
KEYPAD=7
CHANNEL_ON=8
CHANNEL_OFF=9
CHANNEL_STATUS=10
OUTSIDE_INSIDE=11
INSIDE=12
INSIDE_ALERT_VOL=13
LOCAL_PHONE=14
REMOTE_PHONE=15
READ=16
SEND_DATA=17

(* FIND.APEX.VOCABULARY *)
(* SPEAK VOCABULARY, PLEASE NOTE: SOME WORDS IN VOCABULARY *)
(* ARE AXCESS KEYWORDS, OR USED AS CONSTANTS AND DEVICES,  *)
(* THESE ARE DELINIATED WITH "A_".                         *)
A = '233'
Accept = '251'
Access = '024' 
Account = '025' 
A_Active = '278' 
Air = '205' 
Alarm = '384' 
Alert = '026' 
AM = '033' 
A_And = '197' 
Apartment = '402' 
A_Apex = '332' 
Appliance = '027' 
April= '430' 
Are = '028' 
Area = '029' 
Armed = '030' 
Art = '362' 
Asleep = '281' 
At = '306' 
Atrium = '374' 
Attic = '031' 
Audio = '279' 
August = '434' 
Auto = '235' 
Automatic = '283' 
Automation  = '344' 
Awake = '280' 
Away = '032' 
B = '034' 
Baby = '335' 
Back = '035' 
Bar = '176' 
Basement = '036' 
Bathroom = '037' 
Battery = '038' 
Bay = '039' 
Bedroom = '040' 
Bell = '366' 
Boiler = '403' 
Bottom = '041' 
Boys = '042' 
A_Break = '043' 
Breakfast = '418' 
Building = '404' 
Burglary = '392' 
Butler = '373' 
Button = '206' 
Bypassed = '044' 
C = '045' 
Cabana = '295' 
Cabinet = '177' 
A_Call = '388' 
Camera = '207'
Carbon_monoxide = '256' 
Ceiling = '363' 
Center = '208' 
Central = '399' 
Change = '250' 
Check = '385' 
Choices = '317' 
Christmas = '320' 
Circuit = '414' 
Closed = '046' 
Closet = '047' 
Code = '048' 
Coffee = '302' 
Communicator = '175' 
Conservatory = '334' 
Console = '398' 
A_Control = '049' 
Cool = '234' 
Cooling = '247' 
Corner = '050' 
Court = '376' 
Crawlspace = '051' 
Current = '270' 
Curtain = '209' 
D = '052' 
Danger = '401' 
A_Date = '299' 
Debounce = '340' 
Deck = '053' 
Decrease = '346' 
December = '438' 
A_Default = '380' 
Defaults = '381' 
Defined = '284' 
Degrees = '054' 
Delay = '341' 
Den = '055' 
Destiny = '333' 
Detected = '056' 
Detector = '057' 
Device = '397' 
Dialing = '390' 
Digit = '245' 
Dining = '058' 
Disable = '240' 
Disarmed = '059' 
Dock = '217' 
Door = '060' 
Doors = '218' 
Down = '061' 
Driveway = '198' 
E = '062' 
East = '063' 
Eight = '008' 
Eighty = '022' 
Eleven = '011'
Emergency = '327' 
Enable = '239' 
End = '353' 
Energy = '287' 
Enter = '064' 
Entering = '359' 
Entertainment = '286' 
Entry = '065' 
Equipment = '405' 
Error = '252' 
Exercise = '300' 
Expander = '423' 
Exit = '066' 
F = '067' 
Factory = '406' 
Fail = '068' 
Family = '069' 
Fan = '178' 
February = '428' 
Fence = '352' 
Fifteen = '014' 
Fifty = '019' 
Fire = '070' 
First = '071' 
Five = '005' 
Flood = '072' 
Floor = '179' 
Florida = '073' 
Force = '074' 
Forty = '018' 
Fountain = '309' 
Four = '004' 
Foyer = '075' 
Freeze = '290' 
French = '076' 
Friday = '276' 
Front = '077' 
Full = '322' 
Function = '338' 
Furnace = '258' 
Fuse = '078' 
Gallery = '345' 
Game = '310' 
Garage = '079' 
Garden = '377' 
Gas = '180' 
Gate = '199' 
Girls = '080' 
Glass = '081' 
Goodbye = '355' 
Great = '082' 
Green = '369' 
Group = '285' 
Guest = '083' 
Gun = '181' 
Gym = '294' 
H = '232' 
Hall = '084' 
Head = '085' 
Heat = '086' 
Heater = '311' 
Heating = '246' 
Hello = '356' 
High = '219' 
A_Hold = '254' 
Home = '087' 
Hottub = '182' 
Hour = '244' 
House = '183' 
HVAC = '439' 
In = '088' 
Increase = '387'
Input = '339' 
A_Inside = '361'
Instant = '393' 
Interior = '257' 
Intruder = '089' 
Intrusion_detected = '090'
Is = '091' 
Jacuzzi = '370' 
January = '427' 
Jewelry = '184' 
June = '432' 
July = '433' 
Key = '253' 
A_Keypad = '092'
Kitchen = '093' 
Lamp = '094' 
Lanai = '304' 
Laundry = '095' 
Lawn = '296' 
Leak = '308' 
Left = '097' 
Leave_immediately = '096' 
A_Level = '185' 
Library = '098' 
Light = '099' 
Lightning = '347' 
Lights = '100' 
Line = '210' 
Living = '101' 
Loading = '407' 
Lobby = '211' 
Location = '200' 
Lock = '102' 
Loft = '212' 
Loop = '342' 
Low = '103' 
Lower = '213' 
Machine = '408'
Maids = '214' 
Main = '104' 
Management = '288' 
Manual = '236' 
March = '429' 
Master = '105' 
Mat = '215' 
Max = '394' 
May = '431' 
Mechanical = '291' 
Medicine = '186' 
Mens = '216' 
Menu = '231' 
Middle = '106' 
Minute = '396' 
Mode = '107' 
Modes = '243' 
Module = '108' 
Monday = '272' 
Monitor = '187' 
Month = '424' 
Motion = '109' 
Motor = '323' 
Mud = '110' 
Natural = '305' 
Next = '329' 
Night = '111' 
Nine = '009' 
Ninety = '023'
No = '415' 
Nook = '112' 
North = '113' 
November = '437' 
Now = '386' 
Number = '114' 
Nursery = '115' 
O = '116' 
October = '436' 
A_Off = '117' 
Office = '118' 
A_On = '119' 
One = '001' 
Only = '326' 
Open = '120' 
Operating = '268' 
Option = '201' 
Options = '337' 
A_Or = '202' 
Other = '242' 
Out = '121' 
Outlet = '122' 
Over = '123' 
Overhead = '259' 
Overload = '413' 
Panel = '331'
Panic = '220' 
Pantry = '364' 
Parlor = '188' 
Partition = '400' 
Patio = '203' 
Pause = '124' 
Pendant = '221' 
Perimeter = '260' 
Personal = '354' 
Pet = '189' 
Phone = '125' 
Place = '307' 
Play = '126' 
PM = '134' 
Pool = '127' 
Porch = '128' 
Pot = '303' 
Pound = '129' 
Power = '130' 
Pressure = '261' 
Pro = '131' 
Problem = '132' 
Program = '133' 
Protected = '358' 
Pump = '222' 
Radio = '422' 
Raise = '360' 
Reading = '348' 
Ready = '395' 
Rear = '190'
Rec = '135' 
Receiver = '417' 
Red = '367' 
Remain_calm = '136' 
Remote = '137' 
A_Repeat = '230' 
Report = '138' 
Reprogram = '328' 
Restored = '139' 
Restricted_area = '379' 
Right = '140' 
Roof = '223' 
Room = '141' 
Run = '301' 
Safe = '191' 
Saturday = '277' 
Save = '330' 
Screen = '142' 
Second = '143' 
Secure = '312' 
Security = '314' 
Sensor = '144' 
September = '434' 
Serial = '343' 
Servants = '372'
Service = '224' 
Set = '241' 
Setback = '237' 
Setbacks = '238' 
Setpoint = '324' 
Setpoints = '325' 
Setting = '383' 
Seven = '007' 
Seventy = '021' 
Shed = '409' 
Shipping = '225' 
Shock = '145' 
Shop = '146' 
Showing = '147' 
Side = '148' 
Simultaneously = '412' 
Siren = '365' 
Six = '006' 
Sixty = '020' 
Sky = '149' 
Slider = '192' 
Sliding = '150' 
Smart = '313' 
Smoke = '151' 
Soffit = '319' 
South = '152' 
Spa = '193' 
Spare = '153' 
Spot = '419' 
Sprinkler = '297' 
Stairs = '154' 
Stairwell = '350' 
Star = '155' 
Station = '410' 
Stay = '204' 
Stereo = '321' 
Stock = '229' 
Storage = '156' 
Stress = '194' 
Studio = '226' 
Study = '157' 
Suite = '351' 
Sump = '227' 
Sun = '158' 
Sunday = '271' 
A_Switch = '248' 
System = '159' 
Table = '421' 
Tamper = '195' 
Teen = '015' 
Television = '292' 
Temporary = '382' 
Temperature = '160' 
Ten = '010' 
Tenant = '349'
Tennis = '375' 
Test = '416' 
Theater = '316' 
Thermostat = '267' 
Third = '161' 
Thirteen = '013' 
Thirty = '017' 
Three = '003' 
Thursday = '275' 
A_Time = '249' 
Tone = '162' 
Top = '163' 
Transmitter = '262' 
Trespassing = '391' 
Trouble = '164' 
Tuesday = '273' 
Twelve = '012'
Twenty = '016' 
Two = '002' 
Type = '336' 
Under = '165' 
Unit = '166' 
Unoccupied = '282' 
Up = '167' 
User = '168'
Utility = '169' 
Vacation = '269' 
Valve = '378' 
Vanity = '420' 
VCR = '293' 
Video = '315' 
Volume = '389' 
Waiting = '265' 
Walk = '170' 
Warehouse = '266' 
Warning = '371' 
Water = '196' 
Wednesday = '274' 
Welcome = '289' 
West = '171' 
Window = '172' 
Windows = '263' 
Wing = '411' 
Womens = '264' 
Work = '298' 
Yard = '228' 
Year = '425' 
Yellow = '368' 
You = '357' 
Zero = '000' 
Zone = '173' 
A_Zones = '174'

(* APEX KEYPAD KEYS *)
KEY_1 = '1031000101'
KEY_2 = '1031000202'
KEY_3 = '1031000303'
KEY_4 = '1031000404'
KEY_5 = '1031000505'
KEY_6 = '1031000606'
KEY_7 = '1031000707'
KEY_8 = '1031000808'
KEY_9 = '1031000909'
KEY_0 = '1031000000'
KEY_A = '1031000A0A'
KEY_H = '1031000B0B'
KEY_STATUS = '1031001212'
KEY_MONITOR = '1031001313'
KEY_F1 = '1031001414'
KEY_F2 = '1031001515'
KEY_FIRE = '1031002020'
KEY_EMERGENCY = '1031001010'
KEY_PANIC = '1031009999'

(* APEX SYSTEM EVENTS *)
(* AE_ = APEX EVENT   *)
AE_EXTERIOR_INSTANT = '00'
AE_EXTERIOR_DELAY1 = '01'
AE_EXTERIOR_DELAY2 = '02'
AE_INTERIOR_INSTANT = '03'
AE_INTERIOR_DELAY1 = '04'
AE_INTERIOR_DELAY2 = '05'
AE_FIRE = '06'
AE_PANIC = '07'
AE_SILENT = '08'
AE_EMERGENCY = '09'
AE_FOLLOWER = '0A'
AE_AUX_TYPE_1OR2 = '0B'
AE_DURESS = '0C'
AE_DURESS_NOT_ARMED = '0D'
AE_ZONE_REST_AFTER_ACTIVE = '0E'
AE_TRANSMITTER_LOW_BAT = '0F'
AE_TRANS_LOW_BAT_REST = '10'
AE_ZONE_TROUBLE = '11'
AE_ZONE_TROUBLE_REST = '12'
AE_FUSE_TROUBLE = '13'
AE_FUSE_TROUBLE_REST = '14'
AE_PHONE_LINE_REST = '15'
AE_DISARM = '16'
AE_DISARM_AFTER_ACTIVATE = '17'
AE_ARM ='18'
AE_ARM_WITH_ZONES_OPEN ='19'
AE_CTRL_LOW_BATTERY = '1A'
AE_CTRL_BATTERY_REST = '1B'
AE_AC_FAIL = '1C'
AE_AC_RESTORE = '1D'
AE_USER_COMMUNICATOR_TEST = '1E'
AE_AUTO_COMMUNICATOR_TEST = '1F'
AE_CANCEL_ALERT = '20'
AE_ZONE_BYPASS = '21'
AE_ZONE_UNBYPASS = '22'
AE_DAY_ZONE_TROUBLE = '23'
AE_DAY_ZONE_TROUBLE_REST = '24'
AE_UP_DOWNLOAD_ATTEMPT = '25'
AE_PROGRAM_MODE_ENTERED = '26'
AE_FAIL_TO_DISARM = '27'
AE_FAIL_TO_ARM = '28'
AE_HWB416_EXPANDER_TRBLE = '29'
AE_HWB416_TROUBLE_RESTORE = '2A'
AE_ZONE_OPEN = '2B'
AE_ZONE_RESTORE = '2C'


(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE
APEX_BUF[110]         (* BUFFER RS232 PORT FOR APEX RECEIVE STRINGS *)
APEX_TEMP[110]        (* TEMP VARIABLE TO PARSE APEX RECEIVE STRING *)
APEX_ZONES[96][20]    (* APEX ZONE NAME ARRAY *)
APEX_ZONE_STATUS[96]  (* USED TO STORE ZONE STATUS *)
ZONE_STATUS_NAMES[16][20] (* APEX ZONE STATUS NAMES *)
ZONE_NUMBER           (* ZONE NUMBER REPORTED ON EVEN *)
ZONE_TRIGGER          (* USED IN EXAMPLE OF APEX REPORTING EVENT *)
APEX_PARTITION[8][20]   (* APEX PARTITION NAME ARRAY *)
PARTITION_ARM_STATUS[8][15] (* USED TO STORE PARTITION STATUS *)
PARTITION_ASSIGN[96]  (* WHAT PARTITION ARE ZONES ASSIGNED TO *)
CONFIRM_KEY[20]       (* STORE CONFIRM INFORMATION *)
AE_TYPE[45][30]           (* APEX EVENT TYPE *)
AR_COMMAND[1]
AR_SUBCOM[1]
GO_NEXT

(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*           SUBROUTINE DEFINITIONS GO BELOW               *)
(***********************************************************)

(**************************************)
(* NAME: 'SEND TO APEX'               *)
(* PURPOSE: SYSTEM CALL SENDS COMMANDS*)
(*          TO THE APEX DESTINY 6100  *)
(*                                    *)
(* THIS CALL CONTROLS APEX PANEL      *)
(* ARMING, DISARMING, SPEAK, & STATUS.*)
(* PARAMETERS :                       *)
(*    APEX_COMMAND : CONTROL TYPE     *)
(*    APEX_SUBCOM  : SPECIFIES CONTROL*)
(*    APEX_DATA[20]: DATA TO SEND     *)
(**************************************)
DEFINE_CALL 'SEND TO APEX'(APEX_COMMAND,APEX_SUBCOM,APEX_DATA[20])
  LOCAL_VAR A_LENGTH[2] A_COMMAND A_SUBCOM A_DATA[10] CKSM[2] X
{
   ON[TP,1] (* TURN ON BACKLIGHT ON SIMULATED APEX KEYPAD LCD *)
   CANCEL_WAIT 'DISPLAY' (* CANCEL WAIT ON SIMULATED APEX KEYPAD LCD TIMEOUT *)
   SELECT   (* FIND WHICH STRING OF COMMANDS TO SEND, REFER TO CONSTANTS FOR STRING INFORMATION*)
    {
       ACTIVE(APEX_COMMAND=ARM):
       {
          A_COMMAND='a'
          SELECT
          {
              ACTIVE(APEX_SUBCOM=TO_AWAY): (* VALID "DATA" INFORMATION IS USER NUMBER O1-32 COMBINED WITH ARM/DISARM CODE *)
              {
                 A_SUBCOM='a'
              }
              ACTIVE(APEX_SUBCOM=TO_HOME): (* VALID "DATA" INFORMATION IS USER NUMBER O1-32 COMBINED WITH ARM/DISARM CODE *)
              {
                 A_SUBCOM='h'
              }
              ACTIVE(APEX_SUBCOM=DISARM): (* VALID "DATA" INFORMATION IS USER NUMBER O1-32 COMBINED WITH ARM/DISARM CODE *)
              {
                 A_SUBCOM='d'
              }
              ACTIVE(APEX_SUBCOM=STATUS_REQUEST): (* VALID "DATA" INFORMATION IS NULL *)
              {
                 A_SUBCOM='s'
              }
          }
       }
       ACTIVE(APEX_COMMAND=ZONES):
       {
          A_COMMAND='z'
          SELECT
          {
              ACTIVE(APEX_SUBCOM=ZONE_STATUS): (* VALID "DATA" INFORMATION IS NULL *)
              {
                 A_SUBCOM='s'
              }
              ACTIVE(APEX_SUBCOM=PARTITION_STATUS): (* VALID "DATA" INFORMATION IS NULL *)
              {
                 A_SUBCOM='p'
              }
              ACTIVE(APEX_SUBCOM=KEYPAD): (* VALID "DATA" INFORMATION IS THE KEY_ CODES *SEE CONSTANTS FOR KEYS AVAILABLE* *)
              {
                 A_SUBCOM='k'
              }
          }          
       }
       ACTIVE(APEX_COMMAND=CONTROL):
       {
          A_COMMAND='c'
          SELECT
          {
              ACTIVE(APEX_SUBCOM=CHANNEL_ON): (* VALID "DATA" INFORMATION ARE CHANNEL NUMBERS 1-56 *)
              {
                 A_SUBCOM='n'
              }
              ACTIVE(APEX_SUBCOM=CHANNEL_OFF): (* VALID "DATA" INFORMATION ARE CHANNEL NUMBERS 1-56 *)
              {
                 A_SUBCOM='f'
              }
              ACTIVE(APEX_SUBCOM=CHANNEL_STATUS): (* LEAVE BLANK TO QUERY STATUS FROM APEX PANEL *)
              {
                 A_SUBCOM='s'
              }
          }          
       }
       ACTIVE(APEX_COMMAND=SPEAK):
       {
          A_COMMAND='s'
          SELECT
          {
              ACTIVE(APEX_SUBCOM=OUTSIDE_INSIDE): (* SPEAK WHERE? *)
              {
                 A_SUBCOM='o'
              }
              ACTIVE(APEX_SUBCOM=INSIDE): (* SPEAK WHERE? *)
              {
                 A_SUBCOM='i'
              }
              ACTIVE(APEX_SUBCOM=INSIDE_ALERT_VOL): (* SPEAK WHERE? *)
              {
                 A_SUBCOM='a'
              }
              ACTIVE(APEX_SUBCOM=LOCAL_PHONE): (* SPEAK WHERE? *)
              {
                 A_SUBCOM='l'
              }
              ACTIVE(APEX_SUBCOM=REMOTE_PHONE): (* SPEAK WHERE? *)
              {
                 A_SUBCOM='r'
              }
           }          
       }
(********************************************************)
(*                                                      *)
(* The 'Location_Programming, Send Data' command should *)
(* be used with extreme CAUTION.  Writing invalid data  *)
(* to the system can jeopardize the integrity of the    *)
(* system.  Please contact Apex with any programming    *)
(* questions.  The sytem DOES NOT provide error checking*)
(* for valid programming information.  USE THIS FEATURE *)
(* WITH EXTREME CAUTION AND AT YOUR OWN RISK!!          *)
(*                                                      *)
(* VALID DATA FOR LOCATION READ ARE 0-20 (HEX FORMAT)   *)
(* COMBINED WITH STARTING LOCATION                      *)
(* VALID DATA FOR LOCATION SEND DATA ARE 0-20 (HEX)     *)
(* COMBINED WITH STARTINE LOCATION AND DATA (2 CHAR.    *)
(* PER BYTE                                             *)
(********************************************************)
(*       ACTIVE(APEX_COMMAND=LOCATION_PROGRAMMING):     *)
(*       {                                              *)
(*          A_COMMAND='l'                               *)
(*          SELECT                                      *)
(*          {                                           *)
(*              ACTIVE(APEX_SUBCOM=READ):               *)
(*              {                                       *)
(*                 A_SUBCOM='r'                         *)
(*               }                                      *)
(*              ACTIVE(APEX_SUBCOM=SEND_DATA):          *)
(*              {                                       *)
(*                 A_SUBCOM='s'                         *)
(*              }                                       *)
(*          }                                           *)
(*       }                                              *)
(********************************************************)       
    }
    ON[TP,2]    (* TURN ON DATA LED ON APEX KEYPAD *)
    CANCEL_WAIT 'COM' (* CANCEL WAIT TO TURN DATA LED OFF *)
    A_LENGTH="ITOHEX(LENGTH_STRING(APEX_DATA)+8)" (* CALCULATE STRING LENGTH FOR USE WITH CHECKSUM *) 
    IF((LENGTH_STRING(A_LENGTH)=1))
        A_LENGTH="'0',A_LENGTH"
    A_DATA = APEX_DATA
    X=(A_LENGTH[1]+A_LENGTH[2]+A_COMMAND+A_SUBCOM+A_DATA[1] (* BEGIN TO CALCULATE CHECKSUM *)
       +A_DATA[2]+A_DATA[3]+A_DATA[4]+A_DATA[5]+A_DATA[6]
       +A_DATA[7]+A_DATA[8]+A_DATA[9]+A_DATA[10]+48+48)
    X=(($FF-(X%256))+1)
    CKSM=ITOHEX(X)
    IF((LENGTH_STRING(CKSM)=1))
        CKSM="'0',CKSM"
    SEND_STRING APEX,"A_LENGTH,A_COMMAND,A_SUBCOM,A_DATA,'00',CKSM,13,10" (* SEND FORMATTED STRING TO APEX PANEL *)
    A_DATA="0,0,0,0,0,0,0,0,0,0"  (* RESET DATA INFORMATION TO 0 TO ACCURATELY CALCULATE CHECKSUM *)
    WAIT 75 'COM' (* START WAIT TO TURN OFF DATA LED *)
      OFF[TP,2]  (* TURN OFF DATA LED *)
}
(***************************************)
(* NAME: 'ZONE EVENT'                  *)
(* PURPOSE: USE APEX REPORTING EVENTS  *)
(*          TO SOMETHING, ON THE C.S.  *)
(*                                     *)
(* THIS CALL DECIPHERS THE APEX EVENTS *)
(* AND THEN CAN BE USED THROUGHOUT     *)
(* THE CONTROL SYSTEM                  *)
(* PARAMETERS :                        *)
(*    Z_EVENT[20] : REPORTING EVENT    *)
(*                   CALLED FROM CALL  *)
(*                  'RECEIVE FROM APEX'*)
(***************************************)
DEFINE_CALL 'ZONE EVENT' (Z_EVENT[20])
{
  SELECT
  {
    ACTIVE(ZONE_NUMBER = 1):
    {
      SELECT
      {
        ACTIVE(Z_EVENT = 'ZONE OPENED'):
        {
          SEND_COMMAND TP,"'ADBEEP'"
          ZONE_TRIGGER = 1
        }
        ACTIVE(Z_EVENT = 'ZONE RESTORED'):
        {
          SEND_COMMAND TP,"'ADBEEP'"
          ZONE_TRIGGER = 0
          CANCEL_WAIT 'TRIGGER'
        }
      }
    }
  }
}
(***************************************)
(* NAME: 'RECEIVE FROM APEX'           *)
(* PURPOSE: SYSTEM CALL RECEIVES EVENT *)
(*          FROM THE APEX DESTINY 6100 *)
(*                                     *)
(* THIS CALL PROCESSES INFO COMING     *)
(* FROM THE APEX.                      *)
(***************************************)
DEFINE_CALL 'RECEIVE FROM APEX'  (* PROCESS INFORMATION RECEIVED FROM APEX *)
  LOCAL_VAR AR_LENGTH[2] AR_DATA[100] Y TT[2] PNUM AEVENT
{
    IF ((LENGTH_STRING(APEX_BUF)) AND (FIND_STRING(APEX_BUF, "13,10",1)))  (* VERIFY THAT THE APEX BUFFER HAS LENGTH, AND CR LF *)
      {
        ON[TP,2]  (* TURN ON DATA LED ON APEX KEYPAD *)
        CANCEL_WAIT 'COM' (* CANCEL WAIT FOR DATA LED OFF COMMAND *)
        APEX_TEMP = REMOVE_STRING(APEX_BUF,"13,10",1)  (* PARSE STRING FROM APEX *)
        Y = LENGTH_STRING(APEX_TEMP)
        AR_LENGTH = LEFT_STRING(APEX_TEMP,2)
        AR_COMMAND = "APEX_TEMP[3]"
        AR_SUBCOM = "APEX_TEMP[4]"
        AR_DATA = MID_STRING(APEX_TEMP,5,Y-10)
        CLEAR_BUFFER APEX_TEMP
        SELECT  (* SELECT WHAT EVENT HAPPENED ON PANEL *)
        {
          ACTIVE(AR_COMMAND='A'): (* SYSTEM ARMED STATUS *)
          {
            PNUM = 1
            IF(AR_SUBCOM='S')
            {
              WHILE(PNUM<9)  (* ASSIGN ARMING STATUS TO EACH PARTITION *)
              {
                SELECT
                {
                  ACTIVE(AR_DATA[PNUM] = 'A'):
                  {
                    PARTITION_ARM_STATUS[PNUM] = 'ARMED TO AWAY'
                  }
                  ACTIVE(AR_DATA[PNUM] = 'H'):
                  {
                    PARTITION_ARM_STATUS[PNUM] = 'ARMED TO HOME'
                  }
                  ACTIVE(AR_DATA[PNUM] = 'N'):
                  {
                    PARTITION_ARM_STATUS[PNUM] = 'ARMED TO NIGHT'
                  }
                  ACTIVE(AR_DATA[PNUM] = 'D'):
                  {
                    PARTITION_ARM_STATUS[PNUM] = 'DISARMED'
                  }
                }
                PNUM = PNUM + 1
              }
            }
            SELECT  (* UPDATE ARMED STATUS LEDS ON SIMULATED APEX KEYPAD LCD *)
            {
              ACTIVE((PARTITION_ARM_STATUS[1] = 'ARMED TO AWAY')):
              {
                ON[TP,5]
                OFF[TP,3]
              }   
              ACTIVE((PARTITION_ARM_STATUS[1] = 'ARMED TO NIGHT')):
              {
                ON[TP,5]
                ON[TP,3]
              }   
              ACTIVE((PARTITION_ARM_STATUS[1] = 'ARMED TO HOME')):
              {
                OFF[TP,5]
                ON[TP,3]
              }   
              ACTIVE((PARTITION_ARM_STATUS[1] = 'DISARMED')):
              {
                OFF[TP,5]
                OFF[TP,3]
              }   
            }
          }
          ACTIVE(AR_COMMAND='Z'): (* SYSTEM ZONE INFO *)
          {
            SELECT
            {
              ACTIVE(AR_SUBCOM='S'): (* ZONE STATUS *)
              {
                APEX_ZONE_STATUS = AR_DATA
              }
              ACTIVE(AR_SUBCOM='P'): (* PARTITION STATUS *)
              {
                PARTITION_ASSIGN = AR_DATA
                GO_NEXT = 1
              }
            }
          }
          ACTIVE(AR_COMMAND='N'): (* SYSTEM NOTIFICATION *)
          {
            SELECT
            {
              ACTIVE(AR_SUBCOM='K'): (* KEYPAD RESPONSE *)
              {
              
              }
              ACTIVE(AR_SUBCOM='Q'): (* SYSTEM EVENT REFER TO CONSTANTS FOR EVENT TYPE INFORMATION *)
              {
                TT = LEFT_STRING(AR_DATA, 2)  (* EVENT TYPE TEMP *)
                SYSTEM_CALL 'HEXTOI'(TT,AEVENT)
                AEVENT = (AEVENT+1)
                ZONE_NUMBER = (ATOI("MID_STRING(AR_DATA,3,2)")+1) (* ZONE REPORTED *)
                IF((AEVENT < 23) OR ((AEVENT > 26) AND (AEVENT < 45)))
                {
                  ON[TP,4]  (* TURN ON THE STATUS LED ON THE VIRTUAL APEX KEYPAD *)
                }
                ELSE
                {
                  CALL 'SEND TO APEX'(ARM,STATUS_REQUEST,'')  (* GET ZONE, AND PARTITION INFORMATION FOR DISARMED STATUS *)                  
                  OFF[TP,4]     (* TURN OFF THE STATUS LED ON THE VIRTUAL APEX KEYPAD *)
                }
                CALL 'ZONE EVENT'(AE_TYPE[AEVENT]) (* DO SOME PROGRAMMING BASED ON AN APEX EVENT *)
              }
            }
          }
          (* CONTROL CHANNEL EXAMPLE NOT INCLUDED IN THIS CODE BLOCK *)
          ACTIVE(AR_COMMAND='C'):  (* CONTROL STATUS INFO *)
          {
            IF(AR_SUBCOM='S')  (* WILL REPORT THE STATUS OF ALL 56 CHANNELS, 1=On, 0=Off, U=Not programmed *)
            {

            }
          }
          (* LOCATION READ EXAMPLES NOT INCLUDED IN THIS CODE BLOCK *)
          (* SEE WARNING IN LOCATION_PROGRAMMING SEND DATA WARNING  *)
          ACTIVE(AR_COMMAND='L'):  (* LOCATION READ INFO *)
          {
            (* INFORMATION RECEIVED IN THIS SECTION WILL BE             *)
            (* "BBLLLDD"                                                *)
            (* BB - LEGAL VALUES ARE 0-20 (HEX FORMAT: ONE REFERENCED)  *)
            (* LLLL - STARTING LOCATION   (HEX FORMAT: ZERO REFERENCED) *)
            (* DD - DATA: 2 CHARACTERS PER BYTE (HEX: ONE REFERENECED)  *)
            IF(AR_SUBCOM='R')  
            {

            }
          }
        }
        ON[TP,1]  (* TURN ON BACKLIGHT ON SIMULATED APEX KEYPAD LCD *)
        CANCEL_WAIT 'DISPLAY' (* CANCEL WAIT ON SIMULATED APEX KEYPAD LCD TIMEOUT *)
        (* SEND INFO GATHERED, TO SIMULATED APEX KEYPAD LCD, AND PROMPT FOR UPDATE ON ADVANCED PAGE*)
        SELECT
        {
          ACTIVE((AEVENT < 7) OR ((AEVENT > 14) AND (AEVENT < 20)) OR ((AEVENT > 33) AND (AEVENT < 38)) OR (AEVENT > 43)):
          {
            SEND_COMMAND TP,"'TEXT1-SYSTEM REPORTED:|"',AE_TYPE[AEVENT],'"|ZONE ',ITOA(ZONE_NUMBER),'|||'"
            SEND_COMMAND TP,"'!T',2,'NEW INFO!   |PRESS HERE   |TO UPDATE ZONES |||'"
            WAIT 100
              SEND_COMMAND TP,"'TEXT1-SYSTEM ',PARTITION_ARM_STATUS[1],'||||'"
            WAIT 50 
              SEND_COMMAND TP,"'TEXT2-SYSTEM REPORTED:|"',AE_TYPE[AEVENT],'"|ZONE ',ITOA(ZONE_NUMBER),'|||'"
          }
          ACTIVE(((AEVENT > 6) AND (AEVENT < 15)) OR ((AEVENT > 19) AND (AEVENT < 34)) OR ((AEVENT > 37) AND (AEVENT < 44))):
          {
            SEND_COMMAND TP,"'TEXT1-SYSTEM REPORTED:|"',AE_TYPE[AEVENT],'"||||'"
            SEND_COMMAND TP,"'TEXT2-SYSTEM REPORTED:|"',AE_TYPE[AEVENT],'"||||'"
            WAIT 100
            {
              SEND_COMMAND TP,"'TEXT1-SYSTEM ',PARTITION_ARM_STATUS[1],'||||'"
              SEND_COMMAND TP,"'!T',2,'NEW INFO!   |PRESS HERE   |TO UPDATE ZONES |||'"
            }
          }
          ACTIVE(AEVENT = 0):
          {
            SEND_COMMAND TP,"'TEXT1-SYSTEM ',PARTITION_ARM_STATUS[1],'||||'"
            SEND_COMMAND TP,"'!T',2,'NEW INFO!   |PRESS HERE   |TO UPDATE ZONES |||'"
          }
        }
        WAIT 75 'COM' (* WAIT TO TURN OFF DATA LED ON KEYPAD *)
          OFF[TP,2] (* TURN OFF DATA LED ON KEYPAD *)
        WAIT 450 'DISPLAY'  (* WAIT ON SIMULATED APEX KEYPAD LCD TIMEOUT *)
          OFF[TP,1]  (* TURN OFF BACKLIGHT ON SIMULATED APEX KEYPAD LCD *)
   }
}
(*********************************************************************)
(* NAME: 'UPDATE ZONES'                                              *)
(* PURPOSE: SEND UPDATES TO ADVANCED                                 *)
(*          SECURITY PAGE ON TP                                      *)
(*                                                                   *)
(* THIS CALL GETS ALL ZONE INFORMATION                               *)
(* PARTION INFORMATION, AND ARMING                                   *)
(* STATUS FOR PARTITIONS                                             *)
(* PARAMETERS :                                                      *)
(*    ZONE_START    : FIRST ZONE INCLUDED IN QUERY                   *)
(*    ZONE_END      : LAST ZONE INCLUDED IN QUERY                    *)
(*    TP_ZONE_START : FIRST VAR TEXT BUTTON TO DISPLAY ZONE INFO     *)
(*    TP_PAR_START  : FIRST VAR TEXT BUTTON TO DISPLAY PART. INFO    *)
(*    TP_ON_CHAN    : FEEDBACK FOR CHANNEL SPECIFYING ZONE RANGE     *)
(*    TP_OFF_CHAN_START : FEEDBACK FIRST CHAN. NOT SPEC'NG ZONE RANGE*)
(*    TP_OFF_CHAN_END   : FEEDBACK LAST CHAN. NOT SPEC'NG ZONE RANGE *)
(*    TP_LOADBAR    : LEVEL NUMBER USED FOR "LOADING" BAR GRAPH      *)
(*********************************************************************)
(* UPDATE ADVANCED SECURITY PAGE *)
DEFINE_CALL 'UPDATE ZONES' (ZONE_START,ZONE_END,TP_ZONE_START,TP_PAR_START,TP_ON_CHAN,TP_OFF_CHAN_START,TP_OFF_CHAN_END,TP_LOADBAR) (* POPULATE ZONE INFORMATION *)
  LOCAL_VAR ZDEC PARDEC LOADBAR LOADSTART ZONE_COLOR
{
  SEND_COMMAND TP,"'@PPF-ZONES'" (* TURN OFF ZONES PAGE WHILE INFORMATION LOADS *)
  ZONE_COLOR = 4  (* SET INIIAL INDEX FOR ZONE STATUS COLOR *)
  LOADSTART = (255 / (ZONE_END - ZONE_START))  (* CONFIGURE "LOADING.." BAR FIND RATE OF INCREASE *)
  LOADBAR =  LOADSTART (* ASSIGN RATE INCREASE TO LOADING POSSITION *)
  WHILE(TP_OFF_CHAN_START<(TP_OFF_CHAN_END + 1)) (* TURN OFF CHANNELS THAT DEFINE ZONE SEGMENTS *)
  {
    OFF[TP,TP_OFF_CHAN_START]
    TP_OFF_CHAN_START = TP_OFF_CHAN_START + 1
  }
  ON[TP,TP_ON_CHAN]  (* TURN ON APPROPRIATE CHANNEL *)
  MEDIUM_WHILE(ZONE_START<(ZONE_END + 1)) (* LOAD ZONE INFORMATION TO ALL VAR TEXT CHANNELS *)
  {
    ZDEC = (ATOI("APEX_ZONE_STATUS[ZONE_START]") + 1) (* CONVERT TO DECIMAL TO USE AS INDEX *)
    PARDEC = ATOI("PARTITION_ASSIGN[ZONE_START]")  (* CONVERT TO DECIMAL TO USE AS INDEX *)
    SEND_LEVEL TP,TP_LOADBAR,LOADBAR (* BEGIN LOADING BAR *)
    (* SET PARTITION ARM STATUS COLOR EITHER RED OR GREEN DEPENDING ON STATE *)
    IF (PARTITION_ARM_STATUS[PARDEC] = 'DISARMED')
    {
      SEND_COMMAND TP,"'CTOFF',ITOA(TP_PAR_START),'-25'"
    }
    ELSE
    {
      SEND_COMMAND TP,"'CTOFF',ITOA(TP_PAR_START),'-1'"
    }
    (* FIND THE ZONE STATUS AND CHOOSE A DIFFERENT COLOR FOR EACH STATUS, *)
    SEND_COMMAND TP,"'CTOFF',ITOA(TP_ZONE_START),'-'ITOA(ZDEC+ZONE_COLOR)"
    (* START LOADING PARTITION AND ZONE INFORMATION *)
    SEND_COMMAND TP,"'TEXT',ITOA(TP_PAR_START),'-',APEX_PARTITION[PARDEC],'|',PARTITION_ARM_STATUS[PARDEC]"
    SEND_COMMAND TP,"'TEXT',ITOA(TP_ZONE_START),'-',APEX_ZONES[ZONE_START],'|',ZONE_STATUS_NAMES[ZDEC]"
    (* UPDATE INFO FOR THE NEXT TIME *)
    ZONE_START = ZONE_START + 1  
    TP_ZONE_START = TP_ZONE_START + 1
    TP_PAR_START = TP_PAR_START + 1
    LOADBAR = LOADBAR + LOADSTART
    (* LOOP IS DONE LOAD THE PAGE *)
    IF(ZONE_START = ZONE_END)
    {
      SEND_COMMAND TP,"'@PPN-ZONES;SEC_ADV_Z1-96'"
    }
  }
}
(******************************************)
(* NAME: 'CONFIRM'                        *)
(* PURPOSE: TO CONFIRM KEYPAD ACTIVATIONS *)
(*                                        *)
(* THIS CALL ENTERS TROUBLE KEY PRESSED,  *)
(* INTO CONFIRMATION POP-UP.              *)
(* PARAMETERS :                           *)
(*    CONFIRM_TYPE[10] : THE KEY PRESSED  *)
(******************************************)
DEFINE_CALL 'CONFIRM' (CONFIRM_TYPE[10]) (* USED WHEN WANTING TO CONFIRM A KEYPRESS *)
{
  (* LOAD THE CONFIRMATION WINDOW WITH INFO *)
  SEND_COMMAND TP,"'@CTF',67,72"
  SEND_COMMAND TP,"'@CTF',68,87"
  SEND_COMMAND TP,"'TEXT67-'CONFIRM_TYPE"
  SEND_COMMAND TP,"'TEXT68-Do you want to activate ',CONFIRM_TYPE,'?'"
  SELECT  (* ASSIGN THE APEX KEY ENTRY TO THE "OK" BUTTON *)
  {
    ACTIVE(CONFIRM_TYPE = 'FIRE'):
    {
      CONFIRM_KEY = KEY_FIRE
    }
    ACTIVE(CONFIRM_TYPE = 'EMERGENCY'):
    {
      CONFIRM_KEY = KEY_EMERGENCY
    }
    ACTIVE(CONFIRM_TYPE = 'PANIC'):
    {
      CONFIRM_KEY = KEY_PANIC
    }
  }
  SEND_COMMAND TP,"'@PPN-CONFIRM'"  (* DISPLAY CONFIRMATION PROMPT *)
}
(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START
SEND_COMMAND APEX,'SET BAUD 1200,N,8,1' (* CONFIGURE APEX SETTINGS FOR COM PORT *)
CREATE_BUFFER APEX,APEX_BUF

(* SYSTEM STATUS MESSAGES *)
ZONE_STATUS_NAMES[1] = 'CLOSED'
ZONE_STATUS_NAMES[2] = 'OPEN'
ZONE_STATUS_NAMES[3] = 'TROUBLE'
ZONE_STATUS_NAMES[4] = 'OPENED/TROUBLE'
ZONE_STATUS_NAMES[5] = 'ALERT'
ZONE_STATUS_NAMES[6] = 'OPENED/ALERT'
ZONE_STATUS_NAMES[7] = 'ALERT/TROUBLE'
ZONE_STATUS_NAMES[8] = 'OPENED/ALERT/TROUBLE'
ZONE_STATUS_NAMES[9] = 'BYPASSED'
ZONE_STATUS_NAMES[10] = 'OPENED/BYPASSED'
ZONE_STATUS_NAMES[11] = 'BYPASSED/TROUBLE'
ZONE_STATUS_NAMES[12] = 'OPEN/BYPASS/TROUBLE'
ZONE_STATUS_NAMES[13] = 'ALERT/BYPASSED'
ZONE_STATUS_NAMES[14] = 'OPEN/ALERT/BYPASS'
ZONE_STATUS_NAMES[15] = 'ALERT/TROUBLE/BYPASS'
ZONE_STATUS_NAMES[16] = 'OPEN/ALRT/TRBL/BYPASS'

(* SYSTEM EVENT MESSAGES *)
AE_TYPE[1] = 'EXTERIOR INSTANT'
AE_TYPE[2] = 'EXTERIOR DELAY1'
AE_TYPE[3] = 'EXTERIOR DELAY2'
AE_TYPE[4] = 'INTERIOR INSTANT'
AE_TYPE[5] = 'INTERIOR DELAY1'
AE_TYPE[6] = 'INTERIOR DELAY2'
AE_TYPE[7] = 'FIRE'
AE_TYPE[8] = 'PANIC'
AE_TYPE[9] = 'SILENT'
AE_TYPE[10] = 'EMERGENCY'
AE_TYPE[11] = 'FOLLOWER'
AE_TYPE[12] = 'AUXILLARY |TYPE 1 OR 2'
AE_TYPE[13] = 'DURESS'
AE_TYPE[14] = 'DURESS NOT ARMED'
AE_TYPE[15] = 'ZONE RESTORE |AFTER ACTIVATION'
AE_TYPE[16] = 'TRANSMITTER LOW BAT.'
AE_TYPE[17] = 'TRANSMITTER |LOW BAT. |RESTORE'
AE_TYPE[18] = 'ZONE TROUBLE'
AE_TYPE[19] = 'ZONE TROUBLE RESTORE'
AE_TYPE[20] = 'FUSE TROUBLE'
AE_TYPE[21] = 'FUSE TROUBLE RESTORE'
AE_TYPE[22] = 'PHONE LINE RESTORE'
AE_TYPE[23] = 'DISARMED'
AE_TYPE[24] = 'DISARM AFTER |ACTIVATION'
AE_TYPE[25] = 'ARMED'
AE_TYPE[26] = 'ARMED WITH |ZONES OPEN'
AE_TYPE[27] = 'CONTROL LOW BATTERY'
AE_TYPE[28] = 'CONTROL |BATTERY |RESTORE'
AE_TYPE[29] = 'AC POWER FAILURE'
AE_TYPE[30] = 'AC POWER RESTORED'
AE_TYPE[31] = 'USER |COMMUNICATOR |TEST'
AE_TYPE[32] = 'AUTO |COMMUNICATOR |TEST'
AE_TYPE[33] = 'CANCEL ALERT'
AE_TYPE[34] = 'ZONE BYPASSED'
AE_TYPE[35] = 'ZONE UN-BYPASSED'
AE_TYPE[36] = 'DAY ZONE TROUBLE'
AE_TYPE[37] = 'DAY ZONE TROUBLE RESTORED'
AE_TYPE[38] = 'UP/DOWNLOAD_ATTEMPT'
AE_TYPE[39] = 'PROGRAM MODE ENTERED'
AE_TYPE[40] = 'FAILED TO DISARM'
AE_TYPE[41] = 'FAILED TO ARM'
AE_TYPE[42] = 'HWB-416 |EXPANDER TROUBLE'
AE_TYPE[43] = 'HWB-416 |TROUBLE RESTORED'
AE_TYPE[44] = 'ZONE OPENED'
AE_TYPE[45] = 'ZONE RESTORED'

(* FIND.APEX.ZONE.NAMES *)
(* ASSIGN ZONE NAME *)
(* CHANGE THE ZONE NAME TO MATCH SYSTEM *)
(* VERIFY ZONE NAMES WITH SECURITY INSTALLER *)
APEX_ZONES[1] = 'ZONE 1'
APEX_ZONES[2] = 'ZONE 2'
APEX_ZONES[3] = 'ZONE 3'
APEX_ZONES[4] = 'ZONE 4'
APEX_ZONES[5] = 'ZONE 5'
APEX_ZONES[6] = 'ZONE 6'
APEX_ZONES[7] = 'ZONE 7'
APEX_ZONES[8] = 'ZONE 8'
APEX_ZONES[9] = 'ZONE 9'
APEX_ZONES[10] = 'ZONE 10'
APEX_ZONES[11] = 'ZONE 11'
APEX_ZONES[12] = 'ZONE 12'
APEX_ZONES[13] = 'ZONE 13'
APEX_ZONES[14] = 'ZONE 14'
APEX_ZONES[15] = 'ZONE 15'
APEX_ZONES[16] = 'ZONE 16'
APEX_ZONES[17] = 'ZONE 17'
APEX_ZONES[18] = 'ZONE 18'
APEX_ZONES[19] = 'ZONE 19'
APEX_ZONES[20] = 'ZONE 20'
APEX_ZONES[21] = 'ZONE 21'
APEX_ZONES[22] = 'ZONE 22'
APEX_ZONES[23] = 'ZONE 23'
APEX_ZONES[24] = 'ZONE 24'
APEX_ZONES[25] = 'ZONE 25'
APEX_ZONES[26] = 'ZONE 26'
APEX_ZONES[27] = 'ZONE 27'
APEX_ZONES[28] = 'ZONE 28'
APEX_ZONES[29] = 'ZONE 29'
APEX_ZONES[30] = 'ZONE 30'
APEX_ZONES[31] = 'ZONE 31'
APEX_ZONES[32] = 'ZONE 32'
APEX_ZONES[33] = 'ZONE 33'
APEX_ZONES[34] = 'ZONE 34'
APEX_ZONES[35] = 'ZONE 35'
APEX_ZONES[36] = 'ZONE 36'
APEX_ZONES[37] = 'ZONE 37'
APEX_ZONES[38] = 'ZONE 38'
APEX_ZONES[39] = 'ZONE 39'
APEX_ZONES[40] = 'ZONE 40'
APEX_ZONES[41] = 'ZONE 41'
APEX_ZONES[42] = 'ZONE 42'
APEX_ZONES[43] = 'ZONE 43'
APEX_ZONES[44] = 'ZONE 44'
APEX_ZONES[45] = 'ZONE 45'
APEX_ZONES[46] = 'ZONE 46'
APEX_ZONES[47] = 'ZONE 47'
APEX_ZONES[48] = 'ZONE 48'
APEX_ZONES[49] = 'ZONE 49'
APEX_ZONES[50] = 'ZONE 50'
APEX_ZONES[51] = 'ZONE 51'
APEX_ZONES[52] = 'ZONE 52'
APEX_ZONES[53] = 'ZONE 53'
APEX_ZONES[54] = 'ZONE 54'
APEX_ZONES[55] = 'ZONE 55'
APEX_ZONES[56] = 'ZONE 56'
APEX_ZONES[57] = 'ZONE 57'
APEX_ZONES[58] = 'ZONE 58'
APEX_ZONES[59] = 'ZONE 59'
APEX_ZONES[60] = 'ZONE 60'
APEX_ZONES[61] = 'ZONE 61'
APEX_ZONES[62] = 'ZONE 62'
APEX_ZONES[63] = 'ZONE 63'
APEX_ZONES[64] = 'ZONE 64'
APEX_ZONES[65] = 'ZONE 65'
APEX_ZONES[66] = 'ZONE 66'
APEX_ZONES[67] = 'ZONE 67'
APEX_ZONES[68] = 'ZONE 68'
APEX_ZONES[69] = 'ZONE 69'
APEX_ZONES[70] = 'ZONE 70'
APEX_ZONES[71] = 'ZONE 71'
APEX_ZONES[72] = 'ZONE 72'
APEX_ZONES[73] = 'ZONE 73'
APEX_ZONES[74] = 'ZONE 74'
APEX_ZONES[75] = 'ZONE 75'
APEX_ZONES[76] = 'ZONE 76'
APEX_ZONES[77] = 'ZONE 77'
APEX_ZONES[78] = 'ZONE 78'
APEX_ZONES[79] = 'ZONE 79'
APEX_ZONES[80] = 'ZONE 80'
APEX_ZONES[81] = 'ZONE 81'
APEX_ZONES[82] = 'ZONE 82'
APEX_ZONES[83] = 'ZONE 83'
APEX_ZONES[84] = 'ZONE 84'
APEX_ZONES[85] = 'ZONE 85'
APEX_ZONES[86] = 'ZONE 86'
APEX_ZONES[87] = 'ZONE 87'
APEX_ZONES[88] = 'ZONE 88'
APEX_ZONES[89] = 'ZONE 89'
APEX_ZONES[90] = 'ZONE 90'
APEX_ZONES[91] = 'ZONE 91'
APEX_ZONES[92] = 'ZONE 92'
APEX_ZONES[93] = 'ZONE 93'
APEX_ZONES[94] = 'ZONE 94'
APEX_ZONES[95] = 'ZONE 95'
APEX_ZONES[96] = 'ZONE 96'

(* FIND.APEX.PARTITION.NAMES *)
(* ASSIGN PARTITION NAMES *)
(* CHANGE THE PARTITION NAME TO MATCH SYSTEM *)
(* VERIFY PARTITION NAMES WITH SECURITY INSTALLER *)
APEX_PARTITION[1] = 'PARTITION 1'
APEX_PARTITION[2] = 'PARTITION 2'
APEX_PARTITION[3] = 'PARTITION 3'
APEX_PARTITION[4] = 'PARTITION 4'
APEX_PARTITION[5] = 'PARTITION 5'
APEX_PARTITION[6] = 'PARTITION 6'
APEX_PARTITION[7] = 'PARTITION 7'
APEX_PARTITION[8] = 'PARTITION 8'
(* GET CURRENT INFO FROM APEX *)
CALL 'SEND TO APEX'(ARM,STATUS_REQUEST,'')
CALL 'SEND TO APEX'(ZONES,ZONE_STATUS,'')
CALL 'SEND TO APEX'(ZONES,PARTITION_STATUS,'')

(* END *****************************************************)
(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

CALL 'RECEIVE FROM APEX'

PUSH[TP,1] (* LCD SCREEN ON ADVANCED SECURITY PAGE REFRESH *)
{
  GO_NEXT = 0
  (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ARM,STATUS_REQUEST,'')
  WAIT 5
  CALL 'SEND TO APEX'(ZONES,ZONE_STATUS,'')
  WAIT 10
  CALL 'SEND TO APEX'(ZONES,PARTITION_STATUS,'')
  SEND_COMMAND TP,"'@PPX'"
  SEND_LEVEL TP,LOADING_BAR,10
  WAIT_UNTIL(GO_NEXT=1)  (* UPDATE ZONES ON PAGE FLIP *)
  {
    SEND_COMMAND TP,"'ADBEEP'"
    (* CALL 'UPDATE ZONES' (ZONE_START,ZONE_END,TP_ZONE_START,TP_ZONE_END,TP_PAR_START,TP_PAR_END,TP_ON_CHAN,TP_OFF_CHAN_START,TP_OFF_CHAN_END,TP_LOADBAR) *)
    CALL 'UPDATE ZONES' (1,32,35,3,81,81,83,LOADING_BAR)
  }
}
PUSH[TP,62]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_1)
}
PUSH[TP,63]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_2)
}
PUSH[TP,64]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_3)
}
PUSH[TP,65]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_4)
}
PUSH[TP,66]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_5)
}
PUSH[TP,67]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_6)
}
PUSH[TP,68]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_7)
}
PUSH[TP,69]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_8)
}
PUSH[TP,70]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_9)
}
PUSH[TP,71]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_A)
}
PUSH[TP,72]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_0)
}
PUSH[TP,73]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_H)
}
RELEASE[TP,73]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ARM,STATUS_REQUEST,'')  (* NECESSARY TO REPORT SYSTEM ARMED STATUS NIGHT OR HOME *)
}
PUSH[TP,74]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_STATUS)
  CALL 'SEND TO APEX'(ARM,STATUS_REQUEST,'')
  OFF[TP,4]     (* TURN OFF THE STATUS LED ON THE VIRTUAL APEX KEYPAD *)
}
PUSH[TP,75]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_MONITOR)
}
PUSH[TP,76]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_F1)
}
PUSH[TP,77]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,KEY_F2)
}
PUSH[TP,78]
{
   (* CALL 'CONFIRM' (CONFIRM_TYPE[10]) ENTER THE TYPE, THIS INFORMATION WILL BE DISPLAYED ON THE CONFIRMATION PAGE *)
   CALL 'CONFIRM'('FIRE')
}
PUSH[TP,79]
{
   (* CALL 'CONFIRM' (CONFIRM_TYPE[10]) ENTER THE TYPE, THIS INFORMATION WILL BE DISPLAYED ON THE CONFIRMATION PAGE *)
   CALL 'CONFIRM'('EMERGENCY')
}
PUSH[TP,80]
{
   (* CALL 'CONFIRM' (CONFIRM_TYPE[10]) ENTER THE TYPE, THIS INFORMATION WILL BE DISPLAYED ON THE CONFIRMATION PAGE *)
   CALL 'CONFIRM'('PANIC')
}
PUSH[TP,81]
{
   (* CALL 'UPDATE ZONES' (ZONE_START,ZONE_END,TP_ZONE_START,TP_PAR_START,TP_ON_CHAN,TP_OFF_CHAN_START,TP_OFF_CHAN_END,TP_LOADBAR) *)
   CALL 'UPDATE ZONES' (1,32,35,3,81,81,83,LOADING_BAR)
}
PUSH[TP,82]
{
   (* CALL 'UPDATE ZONES' (ZONE_START,ZONE_END,TP_ZONE_START,TP_PAR_START,TP_ON_CHAN,TP_OFF_CHAN_START,TP_OFF_CHAN_END,TP_LOADBAR) *)
   CALL 'UPDATE ZONES' (33,64,35,3,82,81,83,LOADING_BAR)
}
PUSH[TP,83]
{
   (* CALL 'UPDATE ZONES' (ZONE_START,ZONE_END,TP_ZONE_START,TP_PAR_START,TP_ON_CHAN,TP_OFF_CHAN_START,TP_OFF_CHAN_END,TP_LOADBAR) *)
   CALL 'UPDATE ZONES' (65,96,35,3,83,81,83,LOADING_BAR)
}
PUSH[TP,84]
{
  GO_NEXT = 0 
  SEND_COMMAND TP,"'@PPX'"
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND DATA *)
  CALL 'SEND TO APEX'(ARM,STATUS_REQUEST,'')
  CALL 'SEND TO APEX'(ZONES,ZONE_STATUS,'')
  CALL 'SEND TO APEX'(ZONES,PARTITION_STATUS,'')
  (* OPEN ADVANCED SECURITY PAGE *)
  SEND_COMMAND TP,"'PAGE-SEC_ADV_Z1-96'"
  SEND_LEVEL TP,LOADING_BAR,10 (* BEGIN LOADING BAR *)
  WAIT_UNTIL(GO_NEXT=1)
  {
    SEND_COMMAND TP,"'ADBEEP'"
    (* CALL 'UPDATE ZONES' (ZONE_START,ZONE_END,TP_ZONE_START,TP_ZONE_END,TP_PAR_START,TP_PAR_END,TP_ON_CHAN,TP_OFF_CHAN_START,TP_OFF_CHAN_END,TP_LOADBAR) *)
    CALL 'UPDATE ZONES' (1,32,35,3,81,81,83,LOADING_BAR)
    OFF[TP,4]     (* TURN OFF THE STATUS LED ON THE VIRTUAL APEX KEYPAD *)
  }
}
PUSH[TP,87]
{
  (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND CALL 'CONFIRM' FOR DATA *)
  CALL 'SEND TO APEX'(ZONES,KEYPAD,CONFIRM_KEY)
  SEND_COMMAND TP,"'@PPF-CONFIRM'"

}
PUSH[TP,88]
{
  CONFIRM_KEY = '' (* CLEAR CONFIRM KEY *)
}
PUSH[TP,89]
{
   (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND VOCABULARY *)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Servants)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Are)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,In)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Restricted_area)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Butler)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,A_And)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Maids)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Leave_immediately)
}
IF (ZONE_TRIGGER = 1) (* USED IN CONJUNCTION WITH CALL 'ZONE EVENT' AS DEMO OF APEX EVENT PROGRAMMING *)
{
  ZONE_TRIGGER = 0
  (* CALL 'SEND TO APEX' (COMMAND,SUB-COMMAND,DATA), REFER TO CONSTANTS FOR COMMAND, SUB-COMMAND, AND VOCABULARY *)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Zone)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,One)
  CALL 'SEND TO APEX'(SPEAK,INSIDE,Open)
  WAIT 150 'TRIGGER'
    ZONE_TRIGGER = 1
}
(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)

